/*
insn_rlist.c
Copyright © 2009 William Astle

This file is part of LWASM.

LWASM is free software: you can redistribute it and/or modify it under the
terms of the GNU General Public License as published by the Free Software
Foundation, either version 3 of the License, or (at your option) any later
version.

This program is distributed in the hope that it will be useful, but WITHOUT
ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for
more details.

You should have received a copy of the GNU General Public License along with
this program. If not, see <http://www.gnu.org/licenses/>.
*/

/*
for handling inherent mode instructions
*/

#define __insn_rlist_c_seen__

#include "lwasm.h"
#include "instab.h"

OPFUNC(insn_rlist)
{
	int rb = 0;
	int rn;
	static const char *regs = "CCA B DPX Y U PCD S ";

	lwasm_emitop(as, l, instab[opnum].ops[0]);
	while (**p && !isspace(**p))
	{
		rn = lwasm_lookupreg2(regs, p);
		if (rn < 0)
		{
			register_error(as, l, 1, "Bad register '%s'", *p);
			lwasm_emit(as, l, 0);
			return;
		}
		if (**p && **p != ',' && !isspace(**p))
		{
			register_error(as, l, 1, "Bad operand");
			lwasm_emit(as, l, 0);
		}
		if (**p == ',')
			(*p)++;
		if (rn == 8)
			rn = 6;
		else if (rn == 9)
			rn = 0x40;
		else
			rn = 1 << rn;
		rb |= rn;
	}
	lwasm_emit(as, l, rb);
}
